<template>
  <div
    data-component-group="filter-forms"
    data-component="user"
  >
    <FiltersForm
      :has-filters="hasFilters"
      @filter="onFilter"
      @clear="onClearFilters"
    >
      <Can
        I="see-user-search"
        a="filter"
      >
        <v-text-field
          v-model="search"
          type="search"
          label="Search"
          prepend-inner-icon="search"
        />
      </Can>

      <Can
        I="see-user-business"
        a="filter"
      >
        <v-autocomplete
          v-model="business"
          :items="businesses"
          :filter="customFilter"
          :loading="isLoadingBusinesses"
          prepend-inner-icon="home"
          :return-object="true"
          item-text="name"
          label="Business"
          :menu-props="{nudgeBottom:'10'}"
          :search-input.sync="businessSearch"
        />
      </Can>

      <Can
        I="see-user-role"
        a="filter"
      >
        <v-autocomplete
          v-model="role"
          :items="roles"
          :filter="customFilter"
          prepend-inner-icon="supervisor_account"
          :return-object="true"
          item-text="name"
          label="Role"
          :menu-props="{nudgeBottom:'10'}"
        />
      </Can>

      <Can
        I="see-user-status"
        a="filter"
      >
        <v-autocomplete
          v-model="status"
          :items="statuses"
          :filter="customFilter"
          prepend-inner-icon="change_history"
          :return-object="true"
          item-text="name"
          label="Status"
          :menu-props="{nudgeBottom:'10'}"
        />
      </Can>
    </FiltersForm>
  </div>
</template>

<script>
  import uid from 'uid';
  import colors from 'vuetify/es5/util/colors';
  import stringEscape from 'js-string-escape';
  import FiltersForm from './Filters';
  import { isNum, isStr, debounce } from '../../../utils';

  const debouncer = debounce({
    id: uid(),
    timeout: 500
  });

  // TODO: Translate component

  export default {
    components: {
      FiltersForm
    },
    data() {
      return {
        search: '',
        business: {},
        businessSearch: '',
        businesses: [],
        role: {},
        status: {},
        isLoadingBusinesses: false,
        colors
      };
    },
    computed: {
      activeCountry() {
        return this.$store.getters['config/country'];
      },
      hasFilters() {
        const { search, business, role, status } = this;

        return search !== ''
          || isNum(business.id)
          || isStr(role.code)
          || isNum(status.id);
      },
      roles() {
        return this.$store.getters['config/roles'];
      },
      statuses() {
        return this.$store.getters['users/statuses'];
      }
    },
    watch: {
      businessSearch(nextSearch) {
        if (isStr(nextSearch)) {
          debouncer(() => this.getBusinesses(nextSearch));
        }
      }
    },
    methods: {
      getBusinesses(search = '') {
        const query = {
          per_page: -1,
          search,
          target_country: this.activeCountry.code
        };

        this.isLoadingBusinesses = true;
        return this.$store.dispatch('businesses/getItems', query)
          .then(({ items }) => {
            this.businesses = items;
            this.isLoadingBusinesses = false;
            return items;
          })
          .catch((err) => {
            this.isLoadingBusinesses = false;
            return err;
          });
      },
      onFilter() {
        const { search, business, role, status } = this;
        const formattedSearch = stringEscape(search);

        this.$emit('filter', {
          search: formattedSearch,
          business: business.id,
          role: role.code,
          status: status.id
        });
      },
      onClearFilters() {
        this.search = '';
        this.business = {};
        this.role = {};
        this.status = {};

        this.$emit('clearFilters');
      },
      customFilter(item, queryText) {
        const textOne = item.name.toLowerCase();
        const searchText = queryText.toLowerCase();

        return textOne.indexOf(searchText) > -1;
      }
    }
  };
</script>

<style lang="stylus" scoped>
  [data-component-group="filter-forms"] {
    &[data-component="user"] {
      h1 {
        display: flex;
        align-items: center;
        margin: 0 0 32px 0;
        min-height: 48px;
      }
    }
  }
</style>
